#include <time.h>
#include "config.h"
#include <netinet/in.h>
#ifdef REDHAT4
#include <pthread/mit/pthread.h>
#endif
#ifdef REDHAT5
#include <pthread.h>
#endif
#ifdef SOLARIS
#include <pthread.h>
#endif

/* flags */
#define PANIC 1
#define INPUT_READY (1<<1)
#define LAST_CHAR_WAS_N (1<<2)
#define LAST_CHAR_WAS_R (1<<3)
#define DO_LOCAL_ECHO (1<<4)
#define PASSWORD_MODE (1<<5)
#define IBUFFER_LENGTH 512
#define NAME_LENGTH 20

#define PASSWORD 1
#define PROMPT (1<<7)
#define _VERBOSE (1<<8)
#define LOGIN (1<<9)
#define CHUCKOUT (1<<10)
#define EOR_ON (1<<11)
#define IAC_GA_DO (1<<12)
#define SITE_LOG (1<<13)

/* output bit */
#define DOCRLF (1<<2)

/* stupid stuff */
#define CRLF "\n\r"

// commands 
struct frog;
typedef void command_func(struct frog *, char *);

/* terms */
struct terminal
{
   char           *name;
   char           *bold;
   char           *off;
   char           *cls;
};

// main struct for leap frogging
struct frog
{
   char   name[50];
   int    term;
   int    count;
   int    flags;
   int    booted;
   int    bytes_read;
   char   port[50];
   unsigned long temp_long; 
   struct sockaddr_in address;
   fd_set select_1;
   fd_set select_2;
   struct hostent *host_entry;
   struct hostent *host_entry_add;
   unsigned short remote_port;
   char   inetaddr[50];
   char   num_addr[50];
   char   buffer[255];
   int    remote_sock;
   int    remote2_sock;
   pthread_t tid; /* thread id */
   struct sockaddr_in remote_addr;
   int    socket;
   char   *stack; 
   char   *oldstack; 
   char   *totell; // review char 
   char   *data;
   char   *the_data;
   char   *command;
   char   *line;
   int    pid; // ps id #
   int    ppid; // ps ppid #
   int    no_days,no_hours,no_mins,no_secs;
 
   double totaltime; // all time  
   time_t start_logtime;
   time_t logtime; 
   time_t idle;
   command_func *fn; // call fucntion next

   int x;
   
   // back to me
   struct frog *next;
   struct frog *prev;
};

typedef struct frog FROG;

struct saved_player
{
   char inetaddr[50];
   char remote[50];
   unsigned short port;
};

/* thread for threads */
struct player_t
{
   
   int socket;
   int pid;
   char sin_addr[50];
   char *numerical_address;
};

// demo use of command_func
extern command_func send_fd;
extern command_func time_up;
extern command_func view_commands;
extern command_func cls;

extern int logins;

// this is the struct for all commands in cooperation that data is
// passed to functions command_func ie: p()()
struct command
{
   char           *text;
   command_func   *function; 
   int             a;
   int             level;
   int             andlevel;
   int             space;
   char           *help;
   int	           type; 

}; 
